From 3b5ee5d8ffc95cc00cce0228edd66567fdcc8dc4 Mon Sep 17 00:00:00 2001
From: Antonio Huete Jimenez <tuxillo@quantumachine.net>
Date: Tue, 12 Oct 2010 12:49:28 +0200
Subject: [PATCH 2/3] psm - Sync psm(4) with FreeBSD

Changelog:
- Support for A4 Tech RFSW-35 mouse wheel.
- Ignore strange return values in test_aux_port()  from some laptops
  (Compaq, Toshiba, Acer).
- Support synaptics touchpad w/ many features such as supporting integrated
  wheel, up/down buttons or tapping.
- Synaptic tunables hw.psm.tap_enabled and hw.psm.synaptics_support to control
  activation and/or features like gestures.
- Fix many issues with buggy KVM switches which got the mouse confused on sync
  packets.
- ALPS glide point ID.
- Let some PS/2 mice to get directly to Explorer mode (i.e. A4Tech X-7xx)

Obtained-From: FreeBSD
---
 share/man/man4/psm.4         |   57 +-
 sys/dev/misc/kbd/atkbdcreg.h |    4 +
 sys/dev/misc/psm/psm.c       | 6410 +++++++++++++++++++++++++++---------------
 sys/sys/mouse.h              |   25 +
 4 files changed, 4213 insertions(+), 2283 deletions(-)

diff --git a/sys/dev/misc/kbd/atkbdcreg.h b/sys/dev/misc/kbd/atkbdcreg.h
index e4c71e1..07383ec 100644
--- a/sys/dev/misc/kbd/atkbdcreg.h
+++ b/sys/dev/misc/kbd/atkbdcreg.h
@@ -136,6 +136,7 @@
 #define PSM_EXPLORER_ID		4
 #define PSM_4DMOUSE_ID		6
 #define PSM_4DPLUS_ID		8
+#define PSM_4DPLUS_RFSW35_ID  24
 
 #ifdef _KERNEL
 
@@ -211,6 +212,9 @@ enum kbdc_device_ivar {
 
 typedef caddr_t KBDC;
 
+#define KBDC_RID_KBD	 0
+#define KBDC_RID_AUX	 1
+
 /* function prototypes */
 
 atkbdc_softc_t *atkbdc_get_softc(int unit);
diff --git a/sys/dev/misc/psm/psm.c b/sys/dev/misc/psm/psm.c
index 4a6ede1..d7a8535 100644
--- a/sys/dev/misc/psm/psm.c
+++ b/sys/dev/misc/psm/psm.c
@@ -19,11 +19,7 @@
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
- * $FreeBSD: src/sys/isa/psm.c,v 1.23.2.7 2003/11/12 04:26:26 mikeh Exp $
- * $DragonFly: src/sys/dev/misc/psm/psm.c,v 1.25 2007/06/13 17:15:25 dillon Exp $
  */
-
 /*
  *  Ported to 386bsd Oct 17, 1992
  *  Sandi Donno, Computer Science, University of Cape Town, South Africa
@@ -54,14 +50,15 @@
  *  - 12 November 1996. IOCTLs and rearranging `psmread', `psmioctl'...
  *  - 14, 30 November 1996. Uses `kbdio.c'.
  *  - 13 December 1996. Uses queuing version of `kbdio.c'.
- *  - January/February 1997. Tweaked probe logic for 
+ *  - January/February 1997. Tweaked probe logic for
  *    HiNote UltraII/Latitude/Armada laptops.
  *  - 30 July 1997. Added APM support.
- *  - 5 March 1997. Defined driver configuration flags (PSM_CONFIG_XXX). 
+ *  - 5 March 1997. Defined driver configuration flags (PSM_CONFIG_XXX).
  *    Improved sync check logic.
  *    Vendor specific support routines.
+ *
+ * $FreeBSD: src/sys/dev/atkbdc/psm.c,v 1.107 2010/09/09 07:52:15 ed Exp $
  */
-
 #include "opt_psm.h"
 
 #include <sys/param.h>
@@ -75,13 +72,14 @@
 #include <sys/syslog.h>
 #include <sys/malloc.h>
 #include <sys/rman.h>
+#include <sys/sysctl.h>
 #include <sys/thread2.h>
 #include <sys/time.h>
 #include <sys/uio.h>
 
 #include <machine/clock.h>
 #include <machine/limits.h>
-#include <machine/mouse.h>
+#include <sys/mouse.h>
 
 #include <bus/isa/isavar.h>
 #include <dev/misc/kbd/atkbdcreg.h>
@@ -93,231 +91,389 @@
 
 /* debugging */
 #ifndef PSM_DEBUG
-#define PSM_DEBUG	0	/* logging: 0: none, 1: brief, 2: verbose */
+#define	PSM_DEBUG	0	/*
+				 * logging: 0: none, 1: brief, 2: verbose
+				 *          3: sync errors, 4: all packets
+				 */
 #endif
+#define	VLOG(level, args)	do {	\
+	if (verbose >= level)		\
+		log args;		\
+} while (0)
 
-#ifndef PSM_SYNCERR_THRESHOLD1
-#define PSM_SYNCERR_THRESHOLD1	20
+#ifndef PSM_INPUT_TIMEOUT
+#define	PSM_INPUT_TIMEOUT	2000000	/* 2 sec */
 #endif
 
-#ifndef PSM_INPUT_TIMEOUT
-#define PSM_INPUT_TIMEOUT	2000000	/* 2 sec */
+#ifndef PSM_TAP_TIMEOUT
+#define	PSM_TAP_TIMEOUT		125000
+#endif
+
+#ifndef PSM_TAP_THRESHOLD
+#define	PSM_TAP_THRESHOLD	25
 #endif
 
 /* end of driver specific options */
 
-#define PSM_DRIVER_NAME		"psm"
-#define PSMCPNP_DRIVER_NAME	"psmcpnp"
+#define PSM_DRIVER_NAME	      "psm"
+#define	PSMCPNP_DRIVER_NAME	"psmcpnp"
 
 /* input queue */
-#define PSM_BUFSIZE		960
-#define PSM_SMALLBUFSIZE	240
+#define	PSM_BUFSIZE		960
+#define	PSM_SMALLBUFSIZE	240
 
 /* operation levels */
-#define PSM_LEVEL_BASE		0
-#define PSM_LEVEL_STANDARD	1
-#define PSM_LEVEL_NATIVE	2
-#define PSM_LEVEL_MIN		PSM_LEVEL_BASE
-#define PSM_LEVEL_MAX		PSM_LEVEL_NATIVE
+#define	PSM_LEVEL_BASE		0
+#define	PSM_LEVEL_STANDARD	1
+#define	PSM_LEVEL_NATIVE	2
+#define	PSM_LEVEL_MIN		PSM_LEVEL_BASE
+#define	PSM_LEVEL_MAX		PSM_LEVEL_NATIVE
 
 /* Logitech PS2++ protocol */
-#define MOUSE_PS2PLUS_CHECKBITS(b)	\
-				((((b[2] & 0x03) << 2) | 0x02) == (b[1] & 0x0f))
-#define MOUSE_PS2PLUS_PACKET_TYPE(b)	\
-				(((b[0] & 0x30) >> 2) | ((b[1] & 0x30) >> 4))
+#define	MOUSE_PS2PLUS_CHECKBITS(b)	\
+    ((((b[2] & 0x03) << 2) | 0x02) == (b[1] & 0x0f))
+#define	MOUSE_PS2PLUS_PACKET_TYPE(b)	\
+    (((b[0] & 0x30) >> 2) | ((b[1] & 0x30) >> 4))
 
 /* some macros */
-#define PSM_UNIT(dev)		(minor(dev) >> 1)
-#define PSM_NBLOCKIO(dev)	(minor(dev) & 1)
-#define PSM_MKMINOR(unit,block)	((((unit) & 0xff) << 1) | ((block) ? 0:1))
-
-#ifndef max
-#define max(x,y)		((x) > (y) ? (x) : (y))
-#endif
-#ifndef min
-#define min(x,y)		((x) < (y) ? (x) : (y))
-#endif
-
-#define abs(x)			(((x) < 0) ? -(x) : (x))
+#define PSM_UNIT(dev)	      (minor(dev) >> 1)
+#define PSM_NBLOCKIO(dev)     (minor(dev) & 1)
+#define PSM_MKMINOR(unit,block)	   ((((unit) & 0xff) << 1) | ((block) ? 0:1))
 
 /* ring buffer */
 typedef struct ringbuf {
-    int           count;	/* # of valid elements in the buffer */
-    int           head;		/* head pointer */
-    int           tail;		/* tail poiner */
-    unsigned char buf[PSM_BUFSIZE];
+	int		count;	/* # of valid elements in the buffer */
+	int		head;	/* head pointer */
+	int		tail;	/* tail poiner */
+	u_char buf[PSM_BUFSIZE];
 } ringbuf_t;
 
+/* data buffer */
+typedef struct packetbuf {
+	u_char	ipacket[16];	/* interim input buffer */
+	int	inputbytes;	/* # of bytes in the input buffer */
+} packetbuf_t;
+
+#ifndef PSM_PACKETQUEUE
+#define	PSM_PACKETQUEUE	128
+#endif
+
+enum {
+	SYNAPTICS_SYSCTL_MIN_PRESSURE,
+	SYNAPTICS_SYSCTL_MAX_PRESSURE,
+	SYNAPTICS_SYSCTL_MAX_WIDTH,
+	SYNAPTICS_SYSCTL_MARGIN_TOP,
+	SYNAPTICS_SYSCTL_MARGIN_RIGHT,
+	SYNAPTICS_SYSCTL_MARGIN_BOTTOM,
+	SYNAPTICS_SYSCTL_MARGIN_LEFT,
+	SYNAPTICS_SYSCTL_NA_TOP,
+	SYNAPTICS_SYSCTL_NA_RIGHT,
+	SYNAPTICS_SYSCTL_NA_BOTTOM,
+	SYNAPTICS_SYSCTL_NA_LEFT,
+	SYNAPTICS_SYSCTL_WINDOW_MIN,
+	SYNAPTICS_SYSCTL_WINDOW_MAX,
+	SYNAPTICS_SYSCTL_MULTIPLICATOR,
+	SYNAPTICS_SYSCTL_WEIGHT_CURRENT,
+	SYNAPTICS_SYSCTL_WEIGHT_PREVIOUS,
+	SYNAPTICS_SYSCTL_WEIGHT_PREVIOUS_NA,
+	SYNAPTICS_SYSCTL_WEIGHT_LEN_SQUARED,
+	SYNAPTICS_SYSCTL_DIV_MIN,
+	SYNAPTICS_SYSCTL_DIV_MAX,
+	SYNAPTICS_SYSCTL_DIV_MAX_NA,
+	SYNAPTICS_SYSCTL_DIV_LEN,
+	SYNAPTICS_SYSCTL_TAP_MAX_DELTA,
+	SYNAPTICS_SYSCTL_TAP_MIN_QUEUE,
+	SYNAPTICS_SYSCTL_TAPHOLD_TIMEOUT,
+	SYNAPTICS_SYSCTL_VSCROLL_HOR_AREA,
+	SYNAPTICS_SYSCTL_VSCROLL_VER_AREA,
+	SYNAPTICS_SYSCTL_VSCROLL_MIN_DELTA,
+	SYNAPTICS_SYSCTL_VSCROLL_DIV_MIN,
+	SYNAPTICS_SYSCTL_VSCROLL_DIV_MAX
+};
+
+typedef struct synapticsinfo {
+	struct sysctl_ctx_list	 sysctl_ctx;
+	struct sysctl_oid	*sysctl_tree;
+	int			 directional_scrolls;
+	int			 min_pressure;
+	int			 max_pressure;
+	int			 max_width;
+	int			 margin_top;
+	int			 margin_right;
+	int			 margin_bottom;
+	int			 margin_left;
+	int			 na_top;
+	int			 na_right;
+	int			 na_bottom;
+	int			 na_left;
+	int			 window_min;
+	int			 window_max;
+	int			 multiplicator;
+	int			 weight_current;
+	int			 weight_previous;
+	int			 weight_previous_na;
+	int			 weight_len_squared;
+	int			 div_min;
+	int			 div_max;
+	int			 div_max_na;
+	int			 div_len;
+	int			 tap_max_delta;
+	int			 tap_min_queue;
+	int			 taphold_timeout;
+	int			 vscroll_ver_area;
+	int			 vscroll_hor_area;
+	int			 vscroll_min_delta;
+	int			 vscroll_div_min;
+	int			 vscroll_div_max;
+} synapticsinfo_t;
+
+typedef struct synapticspacket {
+	int			x;
+	int			y;
+} synapticspacket_t;
+
+#define	SYNAPTICS_PACKETQUEUE 10
+#define SYNAPTICS_QUEUE_CURSOR(x)					\
+	(x + SYNAPTICS_PACKETQUEUE) % SYNAPTICS_PACKETQUEUE
+
+typedef struct synapticsaction {
+	synapticspacket_t	queue[SYNAPTICS_PACKETQUEUE];
+	int			queue_len;
+	int			queue_cursor;
+	int			window_min;
+	int			start_x;
+	int			start_y;
+	int			avg_dx;
+	int			avg_dy;
+	int			squelch_x;
+	int			squelch_y;
+	int			fingers_nb;
+	int			tap_button;
+	int			in_taphold;
+	int			in_vscroll;
+} synapticsaction_t;
+
 /* driver control block */
 struct psm_softc {		/* Driver status information */
-    int		  unit;
-    struct kqinfo rkq;		/* Processes with registered kevents */
-    unsigned char state;	/* Mouse driver state */
-    int           config;	/* driver configuration flags */
-    int           flags;	/* other flags */
-    KBDC          kbdc;		/* handle to access the keyboard controller */
-    struct resource *intr;	/* IRQ resource */
-    void	  *ih;		/* interrupt handle */
-    mousehw_t     hw;		/* hardware information */
-    mousemode_t   mode;		/* operation mode */
-    mousemode_t   dflt_mode;	/* default operation mode */
-    mousestatus_t status;	/* accumulated mouse movement */
-    ringbuf_t     queue;	/* mouse status queue */
-    unsigned char ipacket[16];	/* interim input buffer */
-    int           inputbytes;	/* # of bytes in the input buffer */
-    int           button;	/* the latest button state */
-    int		  xold;	/* previous absolute X position */
-    int		  yold;	/* previous absolute Y position */
-    int		  syncerrors;
-    struct timeval inputtimeout;
-    int		  watchdog;	/* watchdog timer flag */
-    struct callout callout;	/* watchdog timer call out */
+	int		unit;
+	struct kqinfo rkq;	   /* Processes with registered kevents */
+	u_char		state;		/* Mouse driver state */
+	int		config;		/* driver configuration flags */
+	int		flags;		/* other flags */
+	KBDC		kbdc;		/* handle to access kbd controller */
+	struct resource	*intr;		/* IRQ resource */
+	void		*ih;		/* interrupt handle */
+	mousehw_t	hw;		/* hardware information */
+	synapticshw_t	synhw;		/* Synaptics hardware information */
+	synapticsinfo_t	syninfo;	/* Synaptics configuration */
+	synapticsaction_t synaction;	/* Synaptics action context */
+	mousemode_t	mode;		/* operation mode */
+	mousemode_t	dflt_mode;	/* default operation mode */
+	mousestatus_t	status;		/* accumulated mouse movement */
+	ringbuf_t	queue;		/* mouse status queue */
+	packetbuf_t	pqueue[PSM_PACKETQUEUE]; /* mouse data queue */
+	int		pqueue_start;	/* start of data in queue */
+	int		pqueue_end;	/* end of data in queue */
+	int		button;		/* the latest button state */
+	int		xold;		/* previous absolute X position */
+	int		yold;		/* previous absolute Y position */
+	int		xaverage;	/* average X position */
+	int		yaverage;	/* average Y position */
+	int		squelch; /* level to filter movement at low speed */
+	int		zmax;	/* maximum pressure value for touchpads */
+	int		syncerrors; /* # of bytes discarded to synchronize */
+	int		pkterrors;  /* # of packets failed during quaranteen. */
+	struct timeval	inputtimeout;
+	struct timeval	lastsoftintr;	/* time of last soft interrupt */
+	struct timeval	lastinputerr;	/* time last sync error happened */
+	struct timeval	taptimeout;	/* tap timeout for touchpads */
+	int		watchdog;	/* watchdog timer flag */
+	struct callout	 callout;	/* watchdog timer call out */
+	struct callout	 softcallout; /* buffer timer call out */
+	struct cdev	*dev;
+	struct cdev	*bdev;
+	int		lasterr;
+	int		cmdcount;
+	struct sigio	*async;		/* Processes waiting for SIGIO */
 };
-devclass_t psm_devclass;
-#define PSM_SOFTC(unit)	((struct psm_softc*)devclass_get_softc(psm_devclass, unit))
+static devclass_t psm_devclass;
+#define PSM_SOFTC(unit)	 ((struct psm_softc*)devclass_get_softc(psm_devclass, unit))
 
 /* driver state flags (state) */
-#define PSM_VALID		0x80
-#define PSM_OPEN		1	/* Device is open */
-#define PSM_ASLP		2	/* Waiting for mouse data */
+#define	PSM_VALID		0x80
+#define	PSM_OPEN		1	/* Device is open */
+#define	PSM_ASLP		2	/* Waiting for mouse data */
+#define	PSM_SOFTARMED		4	/* Software interrupt armed */
+#define	PSM_NEED_SYNCBITS	8	/* Set syncbits using next data pkt */
 
 /* driver configuration flags (config) */
-#define PSM_CONFIG_RESOLUTION	0x000f	/* resolution */
-#define PSM_CONFIG_ACCEL	0x00f0  /* acceleration factor */
-#define PSM_CONFIG_NOCHECKSYNC	0x0100  /* disable sync. test */
-#define PSM_CONFIG_NOIDPROBE	0x0200  /* disable mouse model probe */
-#define PSM_CONFIG_NORESET	0x0400  /* don't reset the mouse */
-#define PSM_CONFIG_FORCETAP	0x0800  /* assume `tap' action exists */
-#define PSM_CONFIG_IGNPORTERROR	0x1000  /* ignore error in aux port test */
-#define PSM_CONFIG_HOOKRESUME	0x2000	/* hook the system resume event */
-#define PSM_CONFIG_INITAFTERSUSPEND 0x4000 /* init the device at the resume event */
-#define PSM_CONFIG_SYNCHACK	0x8000 /* enable `out-of-sync' hack */
-
-#define PSM_CONFIG_FLAGS	(PSM_CONFIG_RESOLUTION 		\
-				    | PSM_CONFIG_ACCEL		\
-				    | PSM_CONFIG_NOCHECKSYNC	\
-				    | PSM_CONFIG_SYNCHACK	\
-				    | PSM_CONFIG_NOIDPROBE	\
-				    | PSM_CONFIG_NORESET	\
-				    | PSM_CONFIG_FORCETAP	\
-				    | PSM_CONFIG_IGNPORTERROR	\
-				    | PSM_CONFIG_HOOKRESUME	\
-				    | PSM_CONFIG_INITAFTERSUSPEND)
+#define	PSM_CONFIG_RESOLUTION	0x000f	/* resolution */
+#define	PSM_CONFIG_ACCEL	0x00f0  /* acceleration factor */
+#define	PSM_CONFIG_NOCHECKSYNC	0x0100  /* disable sync. test */
+#define	PSM_CONFIG_NOIDPROBE	0x0200  /* disable mouse model probe */
+#define	PSM_CONFIG_NORESET	0x0400  /* don't reset the mouse */
+#define	PSM_CONFIG_FORCETAP	0x0800  /* assume `tap' action exists */
+#define	PSM_CONFIG_IGNPORTERROR	0x1000  /* ignore error in aux port test */
+#define	PSM_CONFIG_HOOKRESUME	0x2000	/* hook the system resume event */
+#define	PSM_CONFIG_INITAFTERSUSPEND 0x4000 /* init the device at the resume event */
+#define	PSM_CONFIG_SYNCHACK	0x8000	/* enable `out-of-sync' hack */
+
+#define	PSM_CONFIG_FLAGS	\
+    (PSM_CONFIG_RESOLUTION |	\
+    PSM_CONFIG_ACCEL |		\
+    PSM_CONFIG_NOCHECKSYNC |	\
+    PSM_CONFIG_SYNCHACK |	\
+    PSM_CONFIG_NOIDPROBE |	\
+    PSM_CONFIG_NORESET |	\
+    PSM_CONFIG_FORCETAP |	\
+    PSM_CONFIG_IGNPORTERROR |	\
+    PSM_CONFIG_HOOKRESUME |	\
+    PSM_CONFIG_INITAFTERSUSPEND)
 
 /* other flags (flags) */
-#define PSM_FLAGS_FINGERDOWN	0x0001 /* VersaPad finger down */
+#define	PSM_FLAGS_FINGERDOWN	0x0001	/* VersaPad finger down */
+
+/* Tunables */
+static int tap_enabled = -1;
+TUNABLE_INT("hw.psm.tap_enabled", &tap_enabled);
+
+static int synaptics_support = 0;
+TUNABLE_INT("hw.psm.synaptics_support", &synaptics_support);
+
+static int verbose = PSM_DEBUG;
+TUNABLE_INT("debug.psm.loglevel", &verbose);
 
 /* for backward compatibility */
-#define OLD_MOUSE_GETHWINFO	_IOR('M', 1, old_mousehw_t)
-#define OLD_MOUSE_GETMODE	_IOR('M', 2, old_mousemode_t)
-#define OLD_MOUSE_SETMODE	_IOW('M', 3, old_mousemode_t)
+#define	OLD_MOUSE_GETHWINFO	_IOR('M', 1, old_mousehw_t)
+#define	OLD_MOUSE_GETMODE	_IOR('M', 2, old_mousemode_t)
+#define	OLD_MOUSE_SETMODE	_IOW('M', 3, old_mousemode_t)
 
 typedef struct old_mousehw {
-    int buttons;
-    int iftype;
-    int type;
-    int hwid;
+	int	buttons;
+	int	iftype;
+	int	type;
+	int	hwid;
 } old_mousehw_t;
 
 typedef struct old_mousemode {
-    int protocol;
-    int rate;
-    int resolution;
-    int accelfactor;
+	int	protocol;
+	int	rate;
+	int	resolution;
+	int	accelfactor;
 } old_mousemode_t;
 
 /* packet formatting function */
-typedef int packetfunc_t (struct psm_softc *, unsigned char *,
-			      int *, int, mousestatus_t *);
+typedef int	packetfunc_t(struct psm_softc *, u_char *, int *, int,
+    mousestatus_t *);
 
 /* function prototypes */
-static int psmprobe (device_t);
-static int psmattach (device_t);
-static int psmdetach (device_t);
-static int psmresume (device_t);
-
-static d_open_t psmopen;
-static d_close_t psmclose;
-static d_read_t psmread;
-static d_ioctl_t psmioctl;
+static void	psmidentify(driver_t *, device_t);
+static int	psmprobe(device_t);
+static int	psmattach(device_t);
+static int	psmdetach(device_t);
+static int	psmresume(device_t);
+
+static d_open_t		psmopen;
+static d_close_t	psmclose;
+static d_read_t		psmread;
+static d_write_t	psmwrite;
+static d_ioctl_t	psmioctl;
 static d_kqfilter_t psmkqfilter;
 
-static int enable_aux_dev (KBDC);
-static int disable_aux_dev (KBDC);
-static int get_mouse_status (KBDC, int *, int, int);
-static int get_aux_id (KBDC);
-static int set_mouse_sampling_rate (KBDC, int);
-static int set_mouse_scaling (KBDC, int);
-static int set_mouse_resolution (KBDC, int);
-static int set_mouse_mode (KBDC);
-static int get_mouse_buttons (KBDC);
-static int is_a_mouse (int);
-static void recover_from_error (KBDC);
-static int restore_controller (KBDC, int);
-static int doinitialize (struct psm_softc *, mousemode_t *);
-static int doopen (struct psm_softc *, int);
-static int reinitialize (struct psm_softc *, int);
-static char *model_name (int);
-static void psmintr (void *);
-static void psmtimeout (void *);
-static void psmfilter_detach(struct knote *);
-static int psmfilter(struct knote *, long);
+static int	enable_aux_dev(KBDC);
+static int	disable_aux_dev(KBDC);
+static int	get_mouse_status(KBDC, int *, int, int);
+static int	get_aux_id(KBDC);
+static int	set_mouse_sampling_rate(KBDC, int);
+static int	set_mouse_scaling(KBDC, int);
+static int	set_mouse_resolution(KBDC, int);
+static int	set_mouse_mode(KBDC);
+static int	get_mouse_buttons(KBDC);
+static int	is_a_mouse(int);
+static void	recover_from_error(KBDC);
+static int	restore_controller(KBDC, int);
+static int	doinitialize(struct psm_softc *, mousemode_t *);
+static int	doopen(struct psm_softc *, int);
+static int	reinitialize(struct psm_softc *, int);
+static char	*model_name(int);
+static void	psmsoftintr(void *);
+static void	psmintr(void *);
+static void	psmtimeout(void *);
+static void    psmfilter_detach(struct knote *);
+static int     psmfilter(struct knote *, long);
+static int	timeelapsed(const struct timeval *, int, int,
+		    const struct timeval *);
+static void	dropqueue(struct psm_softc *);
+static void	flushpackets(struct psm_softc *);
+static void	proc_mmanplus(struct psm_softc *, packetbuf_t *,
+		    mousestatus_t *, int *, int *, int *);
+static int	proc_synaptics(struct psm_softc *, packetbuf_t *,
+		    mousestatus_t *, int *, int *, int *);
+static void	proc_versapad(struct psm_softc *, packetbuf_t *,
+		    mousestatus_t *, int *, int *, int *);
+static int	tame_mouse(struct psm_softc *, packetbuf_t *, mousestatus_t *,
+		    u_char *);
 
 /* vendor specific features */
-typedef int probefunc_t (struct psm_softc *);
-
-static int mouse_id_proc1 (KBDC, int, int, int *);
-static int mouse_ext_command (KBDC, int);
-static probefunc_t enable_groller;
-static probefunc_t enable_gmouse;
-static probefunc_t enable_aglide; 
-static probefunc_t enable_kmouse;
-static probefunc_t enable_msexplorer;
-static probefunc_t enable_msintelli;
-static probefunc_t enable_4dmouse;
-static probefunc_t enable_4dplus;
-static probefunc_t enable_mmanplus;
-static probefunc_t enable_versapad;
-static int tame_mouse (struct psm_softc *, mousestatus_t *, unsigned char *);
+typedef int	probefunc_t(struct psm_softc *);
+
+static int	mouse_id_proc1(KBDC, int, int, int *);
+static int	mouse_ext_command(KBDC, int);
+
+static probefunc_t	enable_groller;
+static probefunc_t	enable_gmouse;
+static probefunc_t	enable_aglide;
+static probefunc_t	enable_kmouse;
+static probefunc_t	enable_msexplorer;
+static probefunc_t	enable_msintelli;
+static probefunc_t	enable_4dmouse;
+static probefunc_t	enable_4dplus;
+static probefunc_t	enable_mmanplus;
+static probefunc_t	enable_synaptics;
+static probefunc_t	enable_versapad;
 
 static struct {
-    int                 model;
-    unsigned char	syncmask;
-    int 		packetsize;
-    probefunc_t 	*probefunc;
+	int		model;
+	u_char		syncmask;
+	int		packetsize;
+	probefunc_t	*probefunc;
 } vendortype[] = {
-    /*
-     * WARNING: the order of probe is very important.  Don't mess it
-     * unless you know what you are doing.
-     */
-    { MOUSE_MODEL_NET,			/* Genius NetMouse */
-      0x08, MOUSE_PS2INTELLI_PACKETSIZE, enable_gmouse, },
-    { MOUSE_MODEL_NETSCROLL,		/* Genius NetScroll */
-      0xc8, 6, enable_groller, },
-    { MOUSE_MODEL_MOUSEMANPLUS,		/* Logitech MouseMan+ */
-      0x08, MOUSE_PS2_PACKETSIZE, enable_mmanplus, },
-    { MOUSE_MODEL_EXPLORER,		/* Microsoft IntelliMouse Explorer */
-      0x08, MOUSE_PS2INTELLI_PACKETSIZE, enable_msexplorer, },
-    { MOUSE_MODEL_4D,			/* A4 Tech 4D Mouse */
-      0x08, MOUSE_4D_PACKETSIZE, enable_4dmouse, },
-    { MOUSE_MODEL_4DPLUS,		/* A4 Tech 4D+ Mouse */
-      0xc8, MOUSE_4DPLUS_PACKETSIZE, enable_4dplus, },
-    { MOUSE_MODEL_INTELLI,		/* Microsoft IntelliMouse */
-      0x08, MOUSE_PS2INTELLI_PACKETSIZE, enable_msintelli, },
-    { MOUSE_MODEL_GLIDEPOINT,		/* ALPS GlidePoint */
-      0xc0, MOUSE_PS2_PACKETSIZE, enable_aglide, },
-    { MOUSE_MODEL_THINK,		/* Kensignton ThinkingMouse */
-      0x80, MOUSE_PS2_PACKETSIZE, enable_kmouse, },
-    { MOUSE_MODEL_VERSAPAD,		/* Interlink electronics VersaPad */
-      0xe8, MOUSE_PS2VERSA_PACKETSIZE, enable_versapad, },
-    { MOUSE_MODEL_GENERIC,
-      0xc0, MOUSE_PS2_PACKETSIZE, NULL, },
+	/*
+	 * WARNING: the order of probe is very important.  Don't mess it
+	 * unless you know what you are doing.
+	 */
+	{ MOUSE_MODEL_NET,		/* Genius NetMouse */
+	  0x08, MOUSE_PS2INTELLI_PACKETSIZE, enable_gmouse },
+	{ MOUSE_MODEL_NETSCROLL,	/* Genius NetScroll */
+	  0xc8, 6, enable_groller },
+	{ MOUSE_MODEL_MOUSEMANPLUS,	/* Logitech MouseMan+ */
+	  0x08, MOUSE_PS2_PACKETSIZE, enable_mmanplus },
+	{ MOUSE_MODEL_EXPLORER,		/* Microsoft IntelliMouse Explorer */
+	  0x08, MOUSE_PS2INTELLI_PACKETSIZE, enable_msexplorer },
+	{ MOUSE_MODEL_4D,		/* A4 Tech 4D Mouse */
+	  0x08, MOUSE_4D_PACKETSIZE, enable_4dmouse },
+	{ MOUSE_MODEL_4DPLUS,		/* A4 Tech 4D+ Mouse */
+	  0xc8, MOUSE_4DPLUS_PACKETSIZE, enable_4dplus },
+	{ MOUSE_MODEL_SYNAPTICS,	/* Synaptics Touchpad */
+	  0xc0, MOUSE_SYNAPTICS_PACKETSIZE, enable_synaptics },
+	{ MOUSE_MODEL_INTELLI,		/* Microsoft IntelliMouse */
+	  0x08, MOUSE_PS2INTELLI_PACKETSIZE, enable_msintelli },
+	{ MOUSE_MODEL_GLIDEPOINT,	/* ALPS GlidePoint */
+	  0xc0, MOUSE_PS2_PACKETSIZE, enable_aglide },
+	{ MOUSE_MODEL_THINK,		/* Kensington ThinkingMouse */
+	  0x80, MOUSE_PS2_PACKETSIZE, enable_kmouse },
+	{ MOUSE_MODEL_VERSAPAD,		/* Interlink electronics VersaPad */
+	  0xe8, MOUSE_PS2VERSA_PACKETSIZE, enable_versapad },
+	{ MOUSE_MODEL_GENERIC,
+	  0xc0, MOUSE_PS2_PACKETSIZE, NULL },
 };
-#define GENERIC_MOUSE_ENTRY	((sizeof(vendortype) / sizeof(*vendortype)) - 1)
+#define	GENERIC_MOUSE_ENTRY	\
+    ((sizeof(vendortype) / sizeof(*vendortype)) - 1)
 
 /* device driver declarateion */
 static device_method_t psm_methods[] = {
 	/* Device interface */
+	DEVMETHOD(device_identify,	psmidentify),
 	DEVMETHOD(device_probe,		psmprobe),
 	DEVMETHOD(device_attach,	psmattach),
 	DEVMETHOD(device_detach,	psmdetach),
@@ -327,164 +483,144 @@ static device_method_t psm_methods[] = {
 };
 
 static driver_t psm_driver = {
-    PSM_DRIVER_NAME,
-    psm_methods,
-    sizeof(struct psm_softc),
+	PSM_DRIVER_NAME,
+	psm_methods,
+	sizeof(struct psm_softc),
 };
 
-#if notyet
-static struct isa_pnp_id psm_ids[] = {
-    { 0x130fd041, "PS/2 mouse port" },			/* PNP0F13 */
-    { 0x1303d041, "PS/2 port" },			/* PNP0313, XXX */
-    { 0 }
-};
-#endif
-
 #define CDEV_MAJOR        21
 
 static struct dev_ops psm_ops = {
 	{ PSM_DRIVER_NAME, CDEV_MAJOR, 0 },
-	.d_open =	psmopen,
-	.d_close =	psmclose,
-	.d_read =	psmread,
-	.d_ioctl =	psmioctl,
-	.d_kqfilter =	psmkqfilter
+	.d_open =   psmopen,
+	.d_close =  psmclose,
+	.d_read =   psmread,
+	.d_write =  psmwrite,
+	.d_ioctl =  psmioctl,
+	.d_kqfilter =	 psmkqfilter
 };
 
-/* debug message level */
-static int verbose = PSM_DEBUG;
-
 /* device I/O routines */
 static int
 enable_aux_dev(KBDC kbdc)
 {
-    int res;
+	int res;
 
-    res = send_aux_command(kbdc, PSMC_ENABLE_DEV);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: ENABLE_DEV return code:%04x\n", res);
+	res = send_aux_command(kbdc, PSMC_ENABLE_DEV);
+	VLOG(2, (LOG_DEBUG, "psm: ENABLE_DEV return code:%04x\n", res));
 
-    return (res == PSM_ACK);
+	return (res == PSM_ACK);
 }
 
 static int
 disable_aux_dev(KBDC kbdc)
 {
-    int res;
+	int res;
 
-    res = send_aux_command(kbdc, PSMC_DISABLE_DEV);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: DISABLE_DEV return code:%04x\n", res);
+	res = send_aux_command(kbdc, PSMC_DISABLE_DEV);
+	VLOG(2, (LOG_DEBUG, "psm: DISABLE_DEV return code:%04x\n", res));
 
-    return (res == PSM_ACK);
+	return (res == PSM_ACK);
 }
 
 static int
 get_mouse_status(KBDC kbdc, int *status, int flag, int len)
 {
-    int cmd;
-    int res;
-    int i;
-
-    switch (flag) {
-    case 0:
-    default:
-	cmd = PSMC_SEND_DEV_STATUS;
-	break;
-    case 1:
-	cmd = PSMC_SEND_DEV_DATA;
-	break;
-    }
-    empty_aux_buffer(kbdc, 5);
-    res = send_aux_command(kbdc, cmd);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: SEND_AUX_DEV_%s return code:%04x\n", 
-	    (flag == 1) ? "DATA" : "STATUS", res);
-    if (res != PSM_ACK)
-        return 0;
-
-    for (i = 0; i < len; ++i) {
-        status[i] = read_aux_data(kbdc);
-	if (status[i] < 0)
-	    break;
-    }
-
-    if (verbose) {
-        log(LOG_DEBUG, "psm: %s %02x %02x %02x\n",
-            (flag == 1) ? "data" : "status", status[0], status[1], status[2]);
-    }
-
-    return i;
+	int cmd;
+	int res;
+	int i;
+
+	switch (flag) {
+	case 0:
+	default:
+		cmd = PSMC_SEND_DEV_STATUS;
+		break;
+	case 1:
+		cmd = PSMC_SEND_DEV_DATA;
+		break;
+	}
+	empty_aux_buffer(kbdc, 5);
+	res = send_aux_command(kbdc, cmd);
+	VLOG(2, (LOG_DEBUG, "psm: SEND_AUX_DEV_%s return code:%04x\n",
+	    (flag == 1) ? "DATA" : "STATUS", res));
+	if (res != PSM_ACK)
+		return (0);
+
+	for (i = 0; i < len; ++i) {
+		status[i] = read_aux_data(kbdc);
+		if (status[i] < 0)
+			break;
+	}
+
+	VLOG(1, (LOG_DEBUG, "psm: %s %02x %02x %02x\n",
+	    (flag == 1) ? "data" : "status", status[0], status[1], status[2]));
+
+	return (i);
 }
 
 static int
 get_aux_id(KBDC kbdc)
 {
-    int res;
-    int id;
+	int res;
+	int id;
 
-    empty_aux_buffer(kbdc, 5);
-    res = send_aux_command(kbdc, PSMC_SEND_DEV_ID);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: SEND_DEV_ID return code:%04x\n", res);
-    if (res != PSM_ACK)
-	return (-1);
+	empty_aux_buffer(kbdc, 5);
+	res = send_aux_command(kbdc, PSMC_SEND_DEV_ID);
+	VLOG(2, (LOG_DEBUG, "psm: SEND_DEV_ID return code:%04x\n", res));
+	if (res != PSM_ACK)
+		return (-1);
 
-    /* 10ms delay */
-    DRIVERSLEEP(10000);
+	/* 10ms delay */
+	DRIVERSLEEP(10000);
 
-    id = read_aux_data(kbdc);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: device ID: %04x\n", id);
+	id = read_aux_data(kbdc);
+	VLOG(2, (LOG_DEBUG, "psm: device ID: %04x\n", id));
 
-    return id;
+	return (id);
 }
 
 static int
 set_mouse_sampling_rate(KBDC kbdc, int rate)
 {
-    int res;
+	int res;
 
-    res = send_aux_command_and_data(kbdc, PSMC_SET_SAMPLING_RATE, rate);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: SET_SAMPLING_RATE (%d) %04x\n", rate, res);
+	res = send_aux_command_and_data(kbdc, PSMC_SET_SAMPLING_RATE, rate);
+	VLOG(2, (LOG_DEBUG, "psm: SET_SAMPLING_RATE (%d) %04x\n", rate, res));
 
-    return ((res == PSM_ACK) ? rate : -1);
+	return ((res == PSM_ACK) ? rate : -1);
 }
 
 static int
 set_mouse_scaling(KBDC kbdc, int scale)
 {
-    int res;
-
-    switch (scale) {
-    case 1:
-    default:
-	scale = PSMC_SET_SCALING11;
-	break;
-    case 2:
-	scale = PSMC_SET_SCALING21;
-	break;
-    }
-    res = send_aux_command(kbdc, scale);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: SET_SCALING%s return code:%04x\n", 
-	    (scale == PSMC_SET_SCALING21) ? "21" : "11", res);
-
-    return (res == PSM_ACK);
+	int res;
+
+	switch (scale) {
+	case 1:
+	default:
+		scale = PSMC_SET_SCALING11;
+		break;
+	case 2:
+		scale = PSMC_SET_SCALING21;
+		break;
+	}
+	res = send_aux_command(kbdc, scale);
+	VLOG(2, (LOG_DEBUG, "psm: SET_SCALING%s return code:%04x\n",
+	    (scale == PSMC_SET_SCALING21) ? "21" : "11", res));
+
+	return (res == PSM_ACK);
 }
 
 /* `val' must be 0 through PSMD_MAX_RESOLUTION */
 static int
 set_mouse_resolution(KBDC kbdc, int val)
 {
-    int res;
+	int res;
 
-    res = send_aux_command_and_data(kbdc, PSMC_SET_RESOLUTION, val);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: SET_RESOLUTION (%d) %04x\n", val, res);
+	res = send_aux_command_and_data(kbdc, PSMC_SET_RESOLUTION, val);
+	VLOG(2, (LOG_DEBUG, "psm: SET_RESOLUTION (%d) %04x\n", val, res));
 
-    return ((res == PSM_ACK) ? val : -1);
+	return ((res == PSM_ACK) ? val : -1);
 }
 
 /*
@@ -494,37 +630,34 @@ set_mouse_resolution(KBDC kbdc, int val)
 static int
 set_mouse_mode(KBDC kbdc)
 {
-    int res;
+	int res;
 
-    res = send_aux_command(kbdc, PSMC_SET_STREAM_MODE);
-    if (verbose >= 2)
-        log(LOG_DEBUG, "psm: SET_STREAM_MODE return code:%04x\n", res);
+	res = send_aux_command(kbdc, PSMC_SET_STREAM_MODE);
+	VLOG(2, (LOG_DEBUG, "psm: SET_STREAM_MODE return code:%04x\n", res));
 
-    return (res == PSM_ACK);
+	return (res == PSM_ACK);
 }
 
 static int
 get_mouse_buttons(KBDC kbdc)
 {
-    int c = 2;		/* assume two buttons by default */
-    int status[3];
-
-    /*
-     * NOTE: a special sequence to obtain Logitech Mouse specific
-     * information: set resolution to 25 ppi, set scaling to 1:1, set
-     * scaling to 1:1, set scaling to 1:1. Then the second byte of the
-     * mouse status bytes is the number of available buttons.
-     * Some manufactures also support this sequence.
-     */
-    if (set_mouse_resolution(kbdc, PSMD_RES_LOW) != PSMD_RES_LOW)
-        return c;
-    if (set_mouse_scaling(kbdc, 1) && set_mouse_scaling(kbdc, 1)
-        && set_mouse_scaling(kbdc, 1) 
-	&& (get_mouse_status(kbdc, status, 0, 3) >= 3)) {
-        if (status[1] != 0)
-            return status[1];
-    }
-    return c;
+	int c = 2;		/* assume two buttons by default */
+	int status[3];
+
+	/*
+	 * NOTE: a special sequence to obtain Logitech Mouse specific
+	 * information: set resolution to 25 ppi, set scaling to 1:1, set
+	 * scaling to 1:1, set scaling to 1:1. Then the second byte of the
+	 * mouse status bytes is the number of available buttons.
+	 * Some manufactures also support this sequence.
+	 */
+	if (set_mouse_resolution(kbdc, PSMD_RES_LOW) != PSMD_RES_LOW)
+		return (c);
+	if (set_mouse_scaling(kbdc, 1) && set_mouse_scaling(kbdc, 1) &&
+	    set_mouse_scaling(kbdc, 1) &&
+	    get_mouse_status(kbdc, status, 0, 3) >= 3 && status[1] != 0)
+		return (status[1]);
+	return (c);
 }
 
 /* misc subroutines */
